MODULE anim_one;

<*/Resource:anim_one.res*>

FROM WIN32      IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,
                       HDC,HBITMAP,RECT,COLORREF;
FROM WINUSER    IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_TIMER,WM_PAINT,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                       RDW_INVALIDATE,
                       WNDCLASS,MSG,PAINTSTRUCT,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx,
                       ShowWindow,UpdateWindow,GetClientRect,RedrawWindow,
                       SetTimer,KillTimer,TIMERPROC,
                       GetMessage,TranslateMessage,DispatchMessage,
                       BeginPaint,EndPaint,
                       LoadCursor,LoadIcon,FillRect,
                       MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINGDI     IMPORT BITMAP,SRCCOPY,SRCINVERT,SRCAND,SRCPAINT,
                       RGB,
                       GetStockObject,WHITE_BRUSH,
                       CreateBitmap,CreateCompatibleBitmap,
                       CreateCompatibleDC,DeleteDC,
                       SetBkColor,BitBlt;
FROM WINX       IMPORT Instance,CmdShow,NIL_RECT,NULL_HRGN,
                       LoadBitmapId,SelectBitmap,GetBITMAP,DeleteBitmap;

FROM SYSTEM     IMPORT CAST,ADR,FUNC;

FROM resource   IMPORT IDB_BALL;

CONST
    g_szClassName = "myWindowClass";

    ID_TIMER        = 1;
    BALL_MOVE_DELTA = 2;

TYPE
    BALLINFO = RECORD
                 width  : INTEGER;
                 height : INTEGER;
                 x,y    : INTEGER;
                 dx,dy  : INTEGER;
               END;

VAR
    g_ballInfo : BALLINFO ;
    g_hbmBall  : HBITMAP;
    g_hbmMask  : HBITMAP;

PROCEDURE CreateBitmapMask(hbmColour : HBITMAP; crTransparent : COLORREF): HBITMAP;
VAR hdcMem, hdcMem2 : HDC;
    hbmMask         : HBITMAP;
    bm              : BITMAP;
BEGIN

    FUNC GetBITMAP(hbmColour, bm);
    hbmMask := CreateBitmap(bm.bmWidth, bm.bmHeight, 1, 1, NIL);

    hdcMem  := CreateCompatibleDC(NIL);
    hdcMem2 := CreateCompatibleDC(NIL);

    FUNC SelectBitmap(hdcMem, hbmColour);
    FUNC SelectBitmap(hdcMem2, hbmMask);

    FUNC SetBkColor(hdcMem, crTransparent);

    FUNC BitBlt(hdcMem2, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY);

    FUNC BitBlt(hdcMem, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem2, 0, 0, SRCINVERT);

    FUNC DeleteDC(hdcMem);
    FUNC DeleteDC(hdcMem2);

    RETURN hbmMask;
END CreateBitmapMask;


PROCEDURE DrawBall(hdc : HDC; VAR prc : RECT);
VAR hdcBuffer    : HDC;
    hbmBuffer    : HBITMAP;
    hbmOldBuffer : HBITMAP;
    hdcMem       : HDC;
    hbmOld       : HBITMAP;
BEGIN
    hdcBuffer    := CreateCompatibleDC(hdc);
    hbmBuffer    := CreateCompatibleBitmap(hdc, prc.right, prc.bottom);
    hbmOldBuffer := SelectBitmap(hdcBuffer, hbmBuffer);

    hdcMem       := CreateCompatibleDC(hdc);
    hbmOld       := SelectBitmap(hdcMem, g_hbmMask);

    FUNC FillRect(hdcBuffer, prc, CAST(HBRUSH,GetStockObject(WHITE_BRUSH)));

    FUNC BitBlt(hdcBuffer, g_ballInfo.x, g_ballInfo.y,
                g_ballInfo.width, g_ballInfo.height, hdcMem, 0, 0, SRCAND);

    FUNC SelectBitmap(hdcMem, g_hbmBall);
    FUNC BitBlt(hdcBuffer, g_ballInfo.x, g_ballInfo.y,
                g_ballInfo.width, g_ballInfo.height, hdcMem, 0, 0, SRCPAINT);

    FUNC BitBlt(hdc, 0, 0, prc.right, prc.bottom, hdcBuffer, 0, 0, SRCCOPY);

    FUNC SelectBitmap(hdcMem, hbmOld);
    FUNC DeleteDC(hdcMem);

    FUNC SelectBitmap(hdcBuffer, hbmOldBuffer);
    FUNC DeleteDC(hdcBuffer);
    FUNC DeleteBitmap(hbmBuffer);
END DrawBall;

PROCEDURE UpdateBall(VAR prc : RECT);
BEGIN
    INC(g_ballInfo.x,g_ballInfo.dx);
    INC(g_ballInfo.y,g_ballInfo.dy);

    IF g_ballInfo.x < 0 THEN
      g_ballInfo.x  := 0;
      g_ballInfo.dx := BALL_MOVE_DELTA;
    ELSIF g_ballInfo.x + g_ballInfo.width > prc.right THEN
      g_ballInfo.x  := prc.right - g_ballInfo.width;
      g_ballInfo.dx := -BALL_MOVE_DELTA;
    END;

    IF g_ballInfo.y < 0 THEN
      g_ballInfo.y  := 0;
      g_ballInfo.dy := BALL_MOVE_DELTA;
    ELSIF g_ballInfo.y + g_ballInfo.height > prc.bottom THEN
      g_ballInfo.y  := prc.bottom - g_ballInfo.height;
      g_ballInfo.dy := -BALL_MOVE_DELTA;
    END;
END UpdateBall;

(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR rcClient : RECT;
    ret      : UINT;
    bm       : BITMAP;
    hdc      : HDC;
    ps       : PAINTSTRUCT;
BEGIN
    CASE msg OF
    | WM_CREATE     : g_hbmBall := LoadBitmapId(Instance, IDB_BALL);
                      IF g_hbmBall = NIL THEN
                        FUNC MessageBox(hwnd, "Could not load IDB_BALL!", "Error",
                                   MB_OK BOR MB_ICONEXCLAMATION);
                      END;

                      g_hbmMask := CreateBitmapMask(g_hbmBall, RGB(0, 0, 0));
                      IF g_hbmMask = NIL THEN
                        FUNC MessageBox(hwnd, "Could not create mask!", "Error",
                                   MB_OK BOR MB_ICONEXCLAMATION);
                      END;

                      FUNC GetBITMAP(g_hbmBall, bm);

                      g_ballInfo.width  := bm.bmWidth;
                      g_ballInfo.height := bm.bmHeight;
                      g_ballInfo.x      := 0;
                      g_ballInfo.y      := 0;
                      g_ballInfo.dx     := BALL_MOVE_DELTA;
                      g_ballInfo.dy     := BALL_MOVE_DELTA;

                      ret := SetTimer(hwnd, ID_TIMER, 50, CAST(TIMERPROC,NIL));
                      IF ret = 0 THEN
                        FUNC MessageBox(hwnd, "Could not SetTimer()!", "Error",
                                   MB_OK BOR MB_ICONEXCLAMATION);
                      END;
    | WM_TIMER      : FUNC GetClientRect(hwnd, rcClient);
                      UpdateBall(rcClient);
                      FUNC RedrawWindow(hwnd,NIL_RECT,NULL_HRGN,RDW_INVALIDATE);
    | WM_PAINT      : hdc := BeginPaint(hwnd, ps);
                      FUNC GetClientRect(hwnd, rcClient);
                      DrawBall(hdc, rcClient);
                      FUNC EndPaint(hwnd, ps);
    | WM_CLOSE      : FUNC DestroyWindow(hwnd);
    | WM_DESTROY    : FUNC KillTimer(hwnd, ID_TIMER);
                      FUNC DeleteBitmap(g_hbmBall);
                      FUNC DeleteBitmap(g_hbmMask);
                      PostQuitMessage(0);
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;


VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "An Animation Program",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 320, 240,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END anim_one.
