MODULE app_four;

<*/Resource:app_four.res*>

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,HFONT,RECT,
                     HMENU,BOOL,HANDLE,INVALID_HANDLE_VALUE,LPVOID,
                     GENERIC_READ,GENERIC_WRITE,FILE_SHARE_READ,MAX_PATH,
                     OPEN_EXISTING,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,
                     CreateFile,ReadFile,WriteFile,GetFileSize,CloseHandle;
FROM WINUSER  IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_SIZE,WM_SETFONT,
                     WM_CUT,WM_COPY,WM_PASTE,
                     WM_MDICREATE,WM_MDITILE,WM_MDICASCADE,WM_MDIGETACTIVE,
                     WM_MDIACTIVATE,MF_ENABLED,MF_GRAYED,MF_BYPOSITION,
                     WM_COMMAND,IDI_APPLICATION,IDC_ARROW,COLOR_3DFACE,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,LOWORD,MF_BYCOMMAND,
                     WS_CHILD,WS_VISIBLE,WS_VSCROLL,WS_HSCROLL,WS_CLIPCHILDREN,
                     ES_MULTILINE,ES_AUTOVSCROLL,ES_AUTOHSCROLL,DrawMenuBar,
                     CW_USEDEFAULT,WNDCLASS,MSG,MAKEINTRESOURCE,COLOR_WINDOW,
                     CS_HREDRAW,CS_VREDRAW,EnableMenuItem,
                     SendDlgItemMessage,GetSubMenu,GetMenu,DefFrameProc,
                     DestroyWindow,PostQuitMessage,GetWindowRect,
                     RegisterClass,CreateWindowEx,GetClientRect,
                     ShowWindow,UpdateWindow,SendMessage,GetDlgItem,
                     GetMessage,TranslateMessage,DispatchMessage,PostMessage,
                     SetWindowText,GetWindowTextLength,GetWindowText,
                     LoadCursor,LoadIcon,SetWindowPos,SWP_NOZORDER,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK,MB_ICONERROR,
                     MDICREATESTRUCT,CLIENTCREATESTRUCT,
                     DefMDIChildProc,TranslateMDISysAccel;
FROM WINGDI   IMPORT DEFAULT_GUI_FONT;
FROM WINX     IMPORT Instance,CmdShow,
                     NIL_SECURITY_ATTRIBUTES,NIL_DWORD,
                     GetStockFont;

FROM COMMDLG  IMPORT GetOpenFileName,GetSaveFileName,OPENFILENAME,
                     OFN_EXPLORER,OFN_FILEMUSTEXIST,OFN_HIDEREADONLY,
                     OFN_PATHMUSTEXIST,OFN_OVERWRITEPROMPT;
FROM COMMCTRL IMPORT InitCommonControls,TOOLBARCLASSNAME,TBBUTTON,TBADDBITMAP,
                     HINST_COMMCTRL,IDB_STD_SMALL_COLOR,TB_BUTTONSTRUCTSIZE,
                     STD_FILENEW,STD_FILEOPEN,STD_FILESAVE,TB_AUTOSIZE,
                     TBSTATE_ENABLED,TBSTYLE_BUTTON,TB_ADDBITMAP,TB_ADDBUTTONS,
                     STATUSCLASSNAME,SB_SETPARTS,SB_SETTEXT,SBARS_SIZEGRIP;

FROM SYSTEM   IMPORT CAST,ADR,FUNC;
FROM Storage  IMPORT ALLOCATE,DEALLOCATE;

FROM MemUtils IMPORT FillMemBYTE;

FROM resource IMPORT IDR_MAINMENU,ID_FILE_EXIT,ID_FILE_NEW,ID_FILE_OPEN,
                     ID_FILE_SAVEAS,ID_WINDOW_CASCADE,ID_WINDOW_TILE,
                     ID_FILE_CLOSE,ID_FILE_CLOSEALL,ID_EDIT_CUT,
                     ID_EDIT_COPY,ID_EDIT_PASTE;

CONST
    g_szClassName       = "myWindowClass";
    g_szChildClassName = "myMDIChildWindowClass";

    IDC_MAIN_MDI      = 101;
    IDC_MAIN_TOOL     = 102;
    IDC_MAIN_STATUS   = 103;

    IDC_CHILD_EDIT    = 101;

    ID_MDI_FIRSTCHILD = 50000;

VAR

    g_hMDIClient  : HWND;
    g_hMainWindow : HWND;


PROCEDURE LoadTextFileToEdit(hEdit : HWND; FileName : ARRAY OF CHAR) : BOOL;
VAR
    hFile       : HANDLE;
    bSuccess    : BOOL;
    dwFileSize  : CARDINAL;
    dwRead      : CARDINAL;
    pszFileText : POINTER TO ARRAY OF CHAR;
BEGIN
    bSuccess:=FALSE;

    hFile := CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ,
                        NIL_SECURITY_ATTRIBUTES,OPEN_EXISTING, 0, NIL);

    IF hFile # INVALID_HANDLE_VALUE THEN
      dwFileSize := GetFileSize(hFile, NIL_DWORD);
      IF dwFileSize # 0FFFFFFFFH THEN
        NEW(pszFileText,dwFileSize + 1);
        IF pszFileText # NIL THEN
          IF ReadFile(hFile, CAST(LPVOID,pszFileText),
                      dwFileSize, dwRead, NIL) THEN
            pszFileText^[dwFileSize] := 00C; (* Add null terminator *)
            IF SetWindowText(hEdit, pszFileText^) THEN
              bSuccess := TRUE; (* It worked! *)
              DISPOSE(pszFileText);
            END;
          END;
        END;
      END;
      FUNC CloseHandle(hFile);
    END;
    RETURN bSuccess;
END LoadTextFileToEdit;

PROCEDURE SaveTextFileFromEdit(hEdit : HWND; FileName : ARRAY OF CHAR) : BOOL;
VAR
    hFile        : HANDLE;
    bSuccess     : BOOL;
    dwTextLength : CARDINAL;
    dwBufferSize : CARDINAL;
    dwWritten    : CARDINAL;
    pszText      : POINTER TO ARRAY OF CHAR;
BEGIN
    bSuccess:=FALSE;

    hFile := CreateFile(FileName, GENERIC_WRITE, 0, NIL_SECURITY_ATTRIBUTES,
                        CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NIL);

    IF hFile # INVALID_HANDLE_VALUE THEN
      dwTextLength := GetWindowTextLength(hEdit);
      (* No need to bother if there's no text. *)
      IF dwTextLength > 0 THEN
        dwBufferSize := dwTextLength + 1;
        NEW(pszText,dwBufferSize);
        IF pszText # NIL THEN
          IF GetWindowText(hEdit, pszText^, dwBufferSize)>0 THEN
            bSuccess := WriteFile(hFile, CAST(LPVOID,pszText),
                                  dwTextLength, dwWritten, NIL)
          END;
          DISPOSE(pszText);
        END;
      END;
      FUNC CloseHandle(hFile);
    END;
    RETURN bSuccess;
END SaveTextFileFromEdit;


PROCEDURE DoFileOpen(hwnd : HWND);
VAR
    ofn      : OPENFILENAME;
    FileName : ARRAY [0..MAX_PATH] OF CHAR;
    hEdit    : HWND;
BEGIN
    FileName := "";
    FillMemBYTE(ADR(ofn), SIZE(ofn), 0);

    ofn.lStructSize := SIZE(OPENFILENAME);
    ofn.hwndOwner   := hwnd;
    ofn.lpstrFilter := ADR("Text Files (*.txt)"+CHR(0)+"*.txt"+CHR(0)+
                           "All Files (*.*)"+CHR(0)+"*.*"+CHR(0)+CHR(0));
    ofn.lpstrFile   := ADR(FileName);
    ofn.nMaxFile    := MAX_PATH;
    ofn.Flags       := OFN_EXPLORER BOR OFN_FILEMUSTEXIST BOR OFN_HIDEREADONLY;
    ofn.lpstrDefExt := ADR("txt");

    IF GetOpenFileName(ofn) THEN
      hEdit  := GetDlgItem(hwnd, IDC_CHILD_EDIT);
      IF LoadTextFileToEdit(hEdit, FileName) THEN
        SendDlgItemMessage(hwnd, IDC_MAIN_STATUS, SB_SETTEXT, 0,
                           CAST(LPARAM,ADR("Opened...")));
        SendDlgItemMessage(hwnd, IDC_MAIN_STATUS, SB_SETTEXT, 1,
                           CAST(LPARAM,ADR(FileName)));
        SetWindowText(hwnd, FileName);
      END;
    END;
END DoFileOpen;

PROCEDURE DoFileSave(hwnd : HWND);
VAR
    ofn      : OPENFILENAME;
    FileName : ARRAY [0..MAX_PATH] OF CHAR;
    hEdit    : HWND;
BEGIN

    FileName := "";

    FillMemBYTE(ADR(ofn), SIZE(ofn), 0);

    ofn.lStructSize := SIZE(OPENFILENAME);
    ofn.hwndOwner   := hwnd;
    ofn.lpstrFilter := ADR("Text Files (*.txt)"+CHR(0)+"*.txt"+CHR(0)+
                           "All Files (*.*)"+CHR(0)+"*.*"+CHR(0)+CHR(0));
    ofn.lpstrFile   := ADR(FileName);
    ofn.nMaxFile    := MAX_PATH;
    ofn.Flags       := OFN_EXPLORER BOR OFN_PATHMUSTEXIST BOR OFN_HIDEREADONLY
                       BOR OFN_OVERWRITEPROMPT;
    ofn.lpstrDefExt := ADR("txt");

    IF GetSaveFileName(ofn) THEN
      hEdit  := GetDlgItem(hwnd, IDC_CHILD_EDIT);
      IF SaveTextFileFromEdit(hEdit, FileName) THEN
        SendDlgItemMessage(hwnd, IDC_MAIN_STATUS, SB_SETTEXT, 0,
                           CAST(LPARAM,ADR("Saved...")));
        SendDlgItemMessage(hwnd, IDC_MAIN_STATUS, SB_SETTEXT, 1,
                           CAST(LPARAM,ADR(FileName)));
        SetWindowText(hwnd, FileName);
      END;
    END;
END DoFileSave;

PROCEDURE CreateNewMDIChild(hMDIClient : HWND) : HWND;
VAR
    mcs    : MDICREATESTRUCT;
    hChild : HWND;
BEGIN
    mcs.szTitle := ADR("[Untitled]");
    mcs.szClass := ADR(g_szChildClassName);
    mcs.hOwner  := Instance;
    mcs.x       := CW_USEDEFAULT;
    mcs.y       := CW_USEDEFAULT;
    mcs.cx      := CW_USEDEFAULT;
    mcs.cy      := CW_USEDEFAULT;
    mcs.style   := 0;
    mcs.lParam  := 0;

    hChild := CAST(HWND,SendMessage(hMDIClient, WM_MDICREATE, 0,
                                    CAST(LPARAM,ADR(mcs))));
    IF hChild = NIL THEN
      MessageBox(hMDIClient, "MDI Child creation failed.", "Oh Oh...",
                 MB_ICONEXCLAMATION BOR MB_OK);
    END;
    RETURN hChild;
END CreateNewMDIChild;

(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
TYPE intarray = ARRAY [0..1] OF INTEGER;
CONST statwidths = intarray{100,-1};
VAR
    tbb       : ARRAY [0..2] OF TBBUTTON;
    tbab      : TBADDBITMAP;
    ccs       : CLIENTCREATESTRUCT;
    hChild    : HWND;
    hMDI,hStatus,hTool                   : HWND;
    rcClient,rcStatus,rcTool             : RECT;
    iMDIHeight,iStatusHeight,iToolHeight : INTEGER;
BEGIN
    CASE msg OF
    | WM_CREATE  : (* Create MDI Client *)
                   (* Find window menu where children will be listed *)
                   ccs.hWindowMenu  := GetSubMenu(GetMenu(hwnd), 2);
                   ccs.idFirstChild := ID_MDI_FIRSTCHILD;

                   g_hMDIClient := CreateWindowEx(WS_EX_CLIENTEDGE, "mdiclient", "",
                           WS_CHILD BOR WS_CLIPCHILDREN BOR WS_VSCROLL
                           BOR WS_HSCROLL BOR WS_VISIBLE,
                           CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                           hwnd, CAST(HMENU,IDC_MAIN_MDI), Instance, ADR(ccs));

                   IF g_hMDIClient = NIL THEN
                     MessageBox(hwnd, "Could not create MDI client.", "Error",
                                MB_OK BOR MB_ICONERROR);
                   END;

                   (* Create Toolbar *)
                   hTool := CreateWindowEx(0, TOOLBARCLASSNAME, "",
                                 WS_CHILD BOR WS_VISIBLE, 0, 0, 0, 0,
                                 hwnd, CAST(HMENU,IDC_MAIN_TOOL),Instance, NIL);
                   IF hTool = NIL THEN
                     MessageBox(hwnd, "Could not create tool bar.", "Error",
                                MB_OK BOR MB_ICONERROR);
                   END;
                   (* Send the TB_BUTTONSTRUCTSIZE message, which is required for
                      backward compatibility. *)
                   SendMessage(hTool, TB_BUTTONSTRUCTSIZE, SIZE(TBBUTTON), 0);

                   tbab.hInst := HINST_COMMCTRL;
                   tbab.nID   := IDB_STD_SMALL_COLOR;
                   SendMessage(hTool, TB_ADDBITMAP, 0, CAST(LPARAM,ADR(tbab)));

                   FillMemBYTE(ADR(tbb), SIZE(tbb), 0);
                   tbb[0].iBitmap   := STD_FILENEW;
                   tbb[0].fsState   := TBSTATE_ENABLED;
                   tbb[0].fsStyle   := TBSTYLE_BUTTON;
                   tbb[0].idCommand := ID_FILE_NEW;

                   tbb[1].iBitmap   := STD_FILEOPEN;
                   tbb[1].fsState   := TBSTATE_ENABLED;
                   tbb[1].fsStyle   := TBSTYLE_BUTTON;
                   tbb[1].idCommand := ID_FILE_OPEN;

                   tbb[2].iBitmap   := STD_FILESAVE;
                   tbb[2].fsState   := TBSTATE_ENABLED;
                   tbb[2].fsStyle   := TBSTYLE_BUTTON;
                   tbb[2].idCommand := ID_FILE_SAVEAS;

                   SendMessage(hTool, TB_ADDBUTTONS, SIZE(tbb) DIV SIZE(TBBUTTON),
                               CAST(LPARAM,ADR(tbb)));

                   (* Create Status bar *)

                   hStatus := CreateWindowEx(0, STATUSCLASSNAME, "",
                                WS_CHILD BOR WS_VISIBLE BOR SBARS_SIZEGRIP,
                                0, 0, 0, 0, hwnd,
                                CAST(HMENU,IDC_MAIN_STATUS), Instance, NIL);

                   SendMessage(hStatus, SB_SETPARTS,
                               SIZE(statwidths) DIV SIZE(INTEGER),
                               CAST(LPARAM,ADR(statwidths)));
                   SendMessage(hStatus, SB_SETTEXT, 0, CAST(LPARAM,ADR("Hi there :)")));

    | WM_SIZE    : (* Size toolbar and get height *)

                   hTool := GetDlgItem(hwnd, IDC_MAIN_TOOL);
                   SendMessage(hTool, TB_AUTOSIZE, 0, 0);

                   GetWindowRect(hTool, rcTool);
                   iToolHeight := rcTool.bottom - rcTool.top;

                   (* Size status bar and get height *)

                   hStatus := GetDlgItem(hwnd, IDC_MAIN_STATUS);
                   SendMessage(hStatus, WM_SIZE, 0, 0);

                   GetWindowRect(hStatus, rcStatus);
                   iStatusHeight := rcStatus.bottom - rcStatus.top;

                   (* Calculate remaining height and size edit *)

                   GetClientRect(hwnd, rcClient);

                   iMDIHeight := rcClient.bottom - iToolHeight - iStatusHeight;

                   hMDI := GetDlgItem(hwnd, IDC_MAIN_MDI);
                   SetWindowPos(hMDI, NIL, 0, iToolHeight, rcClient.right,
                                iMDIHeight, SWP_NOZORDER);
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT   : PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_FILE_NEW    : CreateNewMDIChild(g_hMDIClient);
      | ID_FILE_OPEN   : hChild := CreateNewMDIChild(g_hMDIClient);
                         IF hChild#NIL THEN
                           DoFileOpen(hChild);
                         END;
      | ID_FILE_CLOSE  : hChild := CAST(HWND,SendMessage(g_hMDIClient,
                                        WM_MDIGETACTIVE,0,0));
                         IF hChild#NIL THEN
                            SendMessage(hChild, WM_CLOSE, 0, 0);
                         END;
      | ID_WINDOW_TILE : SendMessage(g_hMDIClient, WM_MDITILE, 0, 0);
      | ID_WINDOW_CASCADE :
                         SendMessage(g_hMDIClient, WM_MDICASCADE, 0, 0);

      ELSE  IF LOWORD(wParam) >= ID_MDI_FIRSTCHILD THEN
               DefFrameProc(hwnd, g_hMDIClient, WM_COMMAND, wParam, lParam);
            ELSE
               hChild := CAST(HWND,SendMessage(g_hMDIClient, WM_MDIGETACTIVE,0,0));
               IF hChild#NIL THEN
                  SendMessage(hChild, WM_COMMAND, wParam, lParam);
               END;
            END;
      END;
    ELSE
      RETURN DefFrameProc(hwnd, g_hMDIClient, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

(* Exported procedure *)
PROCEDURE MDIChildWndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR
    hfDefault : HFONT;
    hEdit     : HWND;
    rcClient  : RECT;
    hMenu, hFileMenu : HMENU;
    EnableFlag       : UINT;
BEGIN
    CASE msg OF
    | WM_CREATE : (* Create Edit Control *)
                   hEdit := CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "",
                                WS_CHILD BOR WS_VISIBLE BOR WS_VSCROLL
                                BOR WS_HSCROLL BOR ES_MULTILINE
                                BOR ES_AUTOVSCROLL BOR ES_AUTOHSCROLL,
                                0, 0, 100, 100, hwnd, CAST(HMENU,IDC_CHILD_EDIT),
                                Instance, NIL);
                   IF hEdit=NIL THEN
                     MessageBox(hwnd, "Could not create edit box.", "Error",
                                MB_OK BOR MB_ICONERROR);
                     PostQuitMessage(0);
                   ELSE
                     hfDefault := GetStockFont(DEFAULT_GUI_FONT);
                     SendMessage(hEdit, WM_SETFONT, CAST(WPARAM,hfDefault),0);
                   END;
    | WM_MDIACTIVATE:
                   hMenu := GetMenu(g_hMainWindow);
                   IF hwnd = CAST(HWND,lParam) THEN
                     (* being activated, enable the menus *)
                     EnableFlag := MF_ENABLED;
                   ELSE
                     (* being de-activated, gray the menus *)
                     EnableFlag := MF_GRAYED;
                   END;

                   EnableMenuItem(hMenu, 1, MF_BYPOSITION BOR EnableFlag);
                   EnableMenuItem(hMenu, 2, MF_BYPOSITION BOR EnableFlag);

                   hFileMenu := GetSubMenu(hMenu, 0);

                   EnableMenuItem(hFileMenu, ID_FILE_SAVEAS,
                                     MF_BYCOMMAND BOR EnableFlag);
                   EnableMenuItem(hFileMenu, ID_FILE_CLOSE,
                                     MF_BYCOMMAND BOR EnableFlag);
                   EnableMenuItem(hFileMenu, ID_FILE_CLOSEALL,
                                     MF_BYCOMMAND BOR EnableFlag);

                   DrawMenuBar(g_hMainWindow);
    | WM_SIZE    : (* Calculate remaining height and size edit *)
                   GetClientRect(hwnd, rcClient);
                   hEdit := GetDlgItem(hwnd, IDC_CHILD_EDIT);
                   SetWindowPos(hEdit, NIL, 0, 0, rcClient.right, rcClient.bottom, SWP_NOZORDER);
                   RETURN DefMDIChildProc( hwnd, msg, wParam, lParam);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_OPEN   : DoFileOpen(hwnd);
      | ID_FILE_SAVEAS : DoFileSave(hwnd);
      | ID_EDIT_CUT    : SendDlgItemMessage(hwnd, IDC_CHILD_EDIT, WM_CUT, 0, 0);
      | ID_EDIT_COPY   : SendDlgItemMessage(hwnd, IDC_CHILD_EDIT, WM_COPY, 0, 0);
      | ID_EDIT_PASTE  : SendDlgItemMessage(hwnd, IDC_CHILD_EDIT, WM_PASTE, 0, 0);
      ELSE
      END;
    ELSE
      RETURN DefMDIChildProc( hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END MDIChildWndProc;

PROCEDURE SetUpMDIChildWindowClass() : BOOL;
VAR
    wc : WNDCLASS;
BEGIN
    wc.style         := CS_HREDRAW BOR CS_VREDRAW;
    wc.lpfnWndProc   := MDIChildWndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH,COLOR_3DFACE+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szChildClassName);

    IF RegisterClass(wc)=0 THEN
      MessageBox(NIL, "Could Not Register Child Window", "Oh Oh...",
                 MB_ICONEXCLAMATION BOR MB_OK);
      RETURN FALSE;
    ELSE
      RETURN TRUE;
    END;
END SetUpMDIChildWindowClass;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN
    InitCommonControls();

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := MAKEINTRESOURCE(IDR_MAINMENU);
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    IF NOT(SetUpMDIChildWindowClass()) THEN
       FUNC MessageBox(NIL, "MDI Client Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "theForger's Tutorial Application",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 480, 320,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    g_hMainWindow:=hwnd;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
      IF NOT(TranslateMDISysAccel(g_hMDIClient, Msg)) THEN
        FUNC TranslateMessage(Msg);
        FUNC DispatchMessage(Msg);
      END;
    END;
END app_four.
