MODULE app_one;

FROM WIN32      IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,HFONT,RECT,
                       HMENU;
FROM WINUSER    IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_SIZE,WM_SETFONT,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,
                       WS_CHILD,WS_VISIBLE,WS_VSCROLL,WS_HSCROLL,
                       ES_MULTILINE,ES_AUTOVSCROLL,ES_AUTOHSCROLL,
                       CW_USEDEFAULT,WNDCLASS,MSG,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx,GetClientRect,
                       ShowWindow,UpdateWindow,SendMessage,GetDlgItem,
                       GetMessage,TranslateMessage,DispatchMessage,
                       LoadCursor,LoadIcon,SetWindowPos,SWP_NOZORDER,
                       MessageBox,MB_ICONEXCLAMATION,MB_OK,MB_ICONERROR;
FROM WINGDI     IMPORT DEFAULT_GUI_FONT;
FROM WINX       IMPORT Instance,CmdShow,
                       GetStockFont;

FROM SYSTEM     IMPORT CAST,ADR,FUNC;

CONST
    g_szClassName = "myWindowClass";

    IDC_MAIN_EDIT = 101;

PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR
    hfDefault : HFONT;
    hEdit     : HWND;
    rcClient  : RECT;
BEGIN
    CASE msg OF
    | WM_CREATE  : hEdit := CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "",
                                WS_CHILD BOR WS_VISIBLE BOR WS_VSCROLL
                                BOR WS_HSCROLL BOR ES_MULTILINE
                                BOR ES_AUTOVSCROLL BOR ES_AUTOHSCROLL,
                                0, 0, 100, 100, hwnd, CAST(HMENU,IDC_MAIN_EDIT),
                                Instance, NIL);
                   IF hEdit=NIL THEN
                     MessageBox(hwnd, "Could not create edit box.", "Error",
                                MB_OK BOR MB_ICONERROR);
                     PostQuitMessage(0);
                   ELSE
                     hfDefault := GetStockFont(DEFAULT_GUI_FONT);
                     SendMessage(hEdit, WM_SETFONT, CAST(WPARAM,hfDefault),0);
                   END;
    | WM_SIZE    : FUNC GetClientRect(hwnd, rcClient);
                   hEdit := GetDlgItem(hwnd, IDC_MAIN_EDIT);
                   SetWindowPos(hEdit, NIL, 0, 0,
                                rcClient.right, rcClient.bottom, SWP_NOZORDER);
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN
    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "theForger's Tutorial Application",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END app_one.
