MODULE app_two;

<*/Resource:app_two.res*>

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,HFONT,RECT,
                     HMENU,BOOL,HANDLE,INVALID_HANDLE_VALUE,LPVOID,
                     GENERIC_READ,GENERIC_WRITE,FILE_SHARE_READ,MAX_PATH,
                     OPEN_EXISTING,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,
                     CreateFile,ReadFile,WriteFile,GetFileSize,CloseHandle;
FROM WINUSER  IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_SIZE,WM_SETFONT,
                     WM_COMMAND,IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,LOWORD,
                     WS_CHILD,WS_VISIBLE,WS_VSCROLL,WS_HSCROLL,
                     ES_MULTILINE,ES_AUTOVSCROLL,ES_AUTOHSCROLL,
                     CW_USEDEFAULT,WNDCLASS,MSG,MAKEINTRESOURCE,
                     DestroyWindow,PostQuitMessage,DefWindowProc,
                     RegisterClass,CreateWindowEx,GetClientRect,SetDlgItemText,
                     ShowWindow,UpdateWindow,SendMessage,GetDlgItem,
                     GetMessage,TranslateMessage,DispatchMessage,PostMessage,
                     SetWindowText,GetWindowTextLength,GetWindowText,
                     LoadCursor,LoadIcon,SetWindowPos,SWP_NOZORDER,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK,MB_ICONERROR;
FROM WINGDI   IMPORT DEFAULT_GUI_FONT;
FROM WINX     IMPORT Instance,CmdShow,
                     NIL_SECURITY_ATTRIBUTES,NIL_DWORD,
                     GetStockFont;

FROM COMMDLG  IMPORT GetOpenFileName,GetSaveFileName,OPENFILENAME,
                     OFN_EXPLORER,OFN_FILEMUSTEXIST,OFN_HIDEREADONLY,
                     OFN_PATHMUSTEXIST,OFN_OVERWRITEPROMPT;

FROM SYSTEM   IMPORT CAST,ADR,FUNC;
FROM Storage  IMPORT ALLOCATE,DEALLOCATE;

FROM MemUtils IMPORT FillMemBYTE;

FROM resource IMPORT IDR_MAINMENU,ID_FILE_EXIT,ID_FILE_OPEN,
                     ID_FILE_SAVEAS,ID_FILE_NEW;

CONST
    g_szClassName = "myWindowClass";

    IDC_MAIN_EDIT = 101;

PROCEDURE LoadTextFileToEdit(hEdit : HWND; FileName : ARRAY OF CHAR) : BOOL;
VAR
    hFile       : HANDLE;
    bSuccess    : BOOL;
    dwFileSize  : CARDINAL;
    dwRead      : CARDINAL;
    pszFileText : POINTER TO ARRAY OF CHAR;
BEGIN
    bSuccess:=FALSE;

    hFile := CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ,
                        NIL_SECURITY_ATTRIBUTES,OPEN_EXISTING, 0, NIL);

    IF hFile # INVALID_HANDLE_VALUE THEN
      dwFileSize := GetFileSize(hFile, NIL_DWORD);
      IF dwFileSize # 0FFFFFFFFH THEN
        NEW(pszFileText,dwFileSize + 1);
        IF pszFileText # NIL THEN
          IF ReadFile(hFile, CAST(LPVOID,pszFileText),
                      dwFileSize, dwRead, NIL) THEN
            pszFileText^[dwFileSize] := 00C; (* Add null terminator *)
            IF SetWindowText(hEdit, pszFileText^) THEN
              bSuccess := TRUE; (* It worked! *)
              DISPOSE(pszFileText);
            END;
          END;
        END;
      END;
      CloseHandle(hFile);
    END;
    RETURN bSuccess;
END LoadTextFileToEdit;

PROCEDURE SaveTextFileFromEdit(hEdit : HWND; FileName : ARRAY OF CHAR) : BOOL;
VAR
    hFile        : HANDLE;
    bSuccess     : BOOL;
    dwTextLength : CARDINAL;
    dwBufferSize : CARDINAL;
    dwRead       : CARDINAL;
    dwWritten    : CARDINAL;
    pszText      : POINTER TO ARRAY OF CHAR;
BEGIN
    bSuccess:=FALSE;

    hFile := CreateFile(FileName, GENERIC_WRITE, 0, NIL_SECURITY_ATTRIBUTES,
                        CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NIL);

    IF hFile # INVALID_HANDLE_VALUE THEN
      dwTextLength := GetWindowTextLength(hEdit);
      (* No need to bother if there's no text. *)
      IF dwTextLength > 0 THEN
        dwBufferSize := dwTextLength + 1;
        NEW(pszText,dwBufferSize);
        IF pszText # NIL THEN
          IF GetWindowText(hEdit, pszText^, dwBufferSize)>0 THEN
            bSuccess := WriteFile(hFile, CAST(LPVOID,pszText),
                                  dwTextLength, dwWritten, NIL)
          END;
          DISPOSE(pszText);
        END;
      END;
      CloseHandle(hFile);
    END;
    RETURN bSuccess;
END SaveTextFileFromEdit;


PROCEDURE DoFileOpen(hwnd : HWND);
VAR
    ofn      : OPENFILENAME;
    FileName : ARRAY [0..MAX_PATH] OF CHAR;
    hEdit    : HWND;
BEGIN
    FileName := "";
    FillMemBYTE(ADR(ofn), SIZE(ofn), 0);

    ofn.lStructSize := SIZE(OPENFILENAME);
    ofn.hwndOwner   := hwnd;
    ofn.lpstrFilter := ADR("Text Files (*.txt)"+CHR(0)+"*.txt"+CHR(0)+
                           "All Files (*.*)"+CHR(0)+"*.*"+CHR(0)+CHR(0));
    ofn.lpstrFile   := ADR(FileName);
    ofn.nMaxFile    := MAX_PATH;
    ofn.Flags       := OFN_EXPLORER BOR OFN_FILEMUSTEXIST BOR OFN_HIDEREADONLY;
    ofn.lpstrDefExt := ADR("txt");

    IF GetOpenFileName(ofn) THEN
      hEdit  := GetDlgItem(hwnd, IDC_MAIN_EDIT);
      LoadTextFileToEdit(hEdit, FileName);
    END;
END DoFileOpen;


PROCEDURE DoFileSave(hwnd : HWND);
VAR
    ofn      : OPENFILENAME;
    FileName : ARRAY [0..MAX_PATH] OF CHAR;
    hEdit    : HWND;
BEGIN

    FileName := "";

    FillMemBYTE(ADR(ofn), SIZE(ofn), 0);

    ofn.lStructSize := SIZE(OPENFILENAME);
    ofn.hwndOwner   := hwnd;
    ofn.lpstrFilter := ADR("Text Files (*.txt)"+CHR(0)+"*.txt"+CHR(0)+
                           "All Files (*.*)"+CHR(0)+"*.*"+CHR(0)+CHR(0));
    ofn.lpstrFile   := ADR(FileName);
    ofn.nMaxFile    := MAX_PATH;
    ofn.Flags       := OFN_EXPLORER BOR OFN_PATHMUSTEXIST BOR OFN_HIDEREADONLY
                       BOR OFN_OVERWRITEPROMPT;
    ofn.lpstrDefExt := ADR("txt");

    IF GetSaveFileName(ofn) THEN
      hEdit  := GetDlgItem(hwnd, IDC_MAIN_EDIT);
      SaveTextFileFromEdit(hEdit, FileName);
    END;

END DoFileSave;

PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR
    hfDefault : HFONT;
    hEdit     : HWND;
    rcClient  : RECT;
BEGIN
    CASE msg OF
    | WM_CREATE  : hEdit := CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "",
                                WS_CHILD BOR WS_VISIBLE BOR WS_VSCROLL
                                BOR WS_HSCROLL BOR ES_MULTILINE
                                BOR ES_AUTOVSCROLL BOR ES_AUTOHSCROLL,
                                0, 0, 100, 100, hwnd, CAST(HMENU,IDC_MAIN_EDIT),
                                Instance, NIL);
                   IF hEdit=NIL THEN
                     MessageBox(hwnd, "Could not create edit box.", "Error",
                                MB_OK BOR MB_ICONERROR);
                     PostQuitMessage(0);
                   ELSE
                     hfDefault := GetStockFont(DEFAULT_GUI_FONT);
                     SendMessage(hEdit, WM_SETFONT, CAST(WPARAM,hfDefault),0);
                   END;
    | WM_SIZE    : FUNC GetClientRect(hwnd, rcClient);
                   hEdit := GetDlgItem(hwnd, IDC_MAIN_EDIT);
                   SetWindowPos(hEdit, NIL, 0, 0,
                                rcClient.right, rcClient.bottom, SWP_NOZORDER);
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT   : PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_FILE_NEW    : SetDlgItemText(hwnd, IDC_MAIN_EDIT, "");
      | ID_FILE_OPEN   : DoFileOpen(hwnd);
      | ID_FILE_SAVEAS : DoFileSave(hwnd);
      ELSE
      END;
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN
    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := MAKEINTRESOURCE(IDR_MAINMENU);
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "theForger's Tutorial Application",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 480, 320,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END app_two.
