MODULE bmp_one;

<*/Resource:bmp_one.res*>

FROM WIN32      IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,
                       HDC,HBITMAP;
FROM WINUSER    IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_PAINT,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                       WNDCLASS,MSG,PAINTSTRUCT,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx,
                       ShowWindow,UpdateWindow,
                       GetMessage,TranslateMessage,DispatchMessage,
                       BeginPaint,EndPaint,
                       LoadCursor,LoadIcon,
                       MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINGDI     IMPORT BITMAP,SRCCOPY,
                       CreateCompatibleDC,DeleteDC,BitBlt;
FROM WINX       IMPORT Instance,CmdShow,
                       LoadBitmapId,SelectBitmap,GetBITMAP,DeleteBitmap;

FROM SYSTEM     IMPORT CAST,ADR,FUNC;

FROM resource   IMPORT IDB_BALL;

CONST
    g_szClassName = "myWindowClass";

VAR
    g_hbmBall : HBITMAP;

(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR bm       : BITMAP;
    hbmOld   : HBITMAP;
    hdc      : HDC;
    hdcMem   : HDC;
    ps       : PAINTSTRUCT;
BEGIN
    CASE msg OF
    | WM_CREATE  : g_hbmBall := LoadBitmapId(Instance, IDB_BALL);
                   IF g_hbmBall = NIL THEN
                     FUNC MessageBox(hwnd, "Could not load IDB_BALL!", "Error",
                                     MB_OK BOR MB_ICONEXCLAMATION);
                   END;
    | WM_PAINT   : (* Just a note, never use a MessageBox from inside WM_PAINT.
                      The box will cause more WM_PAINT messages and you'll
                      probably end up stuck in a loop *)
                   hdc    := BeginPaint(hwnd, ps);
                   hdcMem := CreateCompatibleDC(hdc);
                   hbmOld := SelectBitmap(hdcMem, g_hbmBall);
                   FUNC GetBITMAP(g_hbmBall, bm);
                   FUNC BitBlt(hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem,
                               0, 0, SRCCOPY);
                   FUNC SelectBitmap(hdcMem, hbmOld);
                   FUNC DeleteDC(hdcMem);
                   FUNC EndPaint(hwnd, ps);
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : FUNC DeleteBitmap(g_hbmBall);
                   PostQuitMessage(0);
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "A Bitmap Program",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END bmp_one.
