MODULE bmp_two;

<*/Resource:bmp_two.res*>

FROM WIN32      IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,
                       HDC,HBITMAP,COLORREF,RECT;
FROM WINUSER    IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_PAINT,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                       WNDCLASS,MSG,PAINTSTRUCT,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx,
                       ShowWindow,UpdateWindow,GetClientRect,
                       GetMessage,TranslateMessage,DispatchMessage,
                       BeginPaint,EndPaint,FillRect,
                       LoadCursor,LoadIcon,
                       MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINGDI     IMPORT BITMAP,SRCCOPY,SRCINVERT,SRCAND,SRCPAINT,RGB,
                       CreateCompatibleDC,DeleteDC,BitBlt,
                       CreateBitmap,SetBkColor,LTGRAY_BRUSH;
FROM WINX       IMPORT Instance,CmdShow,
                       LoadBitmapId,SelectBitmap,GetBITMAP,DeleteBitmap,
                       GetStockBrush;

FROM SYSTEM     IMPORT CAST,ADR,FUNC;

FROM resource   IMPORT IDB_BALL;

CONST
    g_szClassName = "myWindowClass";

VAR
    g_hbmBall : HBITMAP;
    g_hbmMask : HBITMAP;

PROCEDURE CreateBitmapMask(hbmColour: HBITMAP; crTransparent: COLORREF): HBITMAP;
VAR hdcMem, hdcMem2 : HDC;
    hbmMask         : HBITMAP;
    bm              : BITMAP;
BEGIN
    (* Create monochrome (1 bit) mask bitmap. *)
    FUNC GetBITMAP(hbmColour, bm);
    hbmMask := CreateBitmap(bm.bmWidth, bm.bmHeight, 1, 1, NIL);
    (* Get some HDCs that are compatible with the display driver *)
    hdcMem  := CreateCompatibleDC(NIL);
    hdcMem2 := CreateCompatibleDC(NIL);

    FUNC SelectBitmap(hdcMem, hbmColour);
    FUNC SelectBitmap(hdcMem2, hbmMask);
    (* Set the background colour of the colour image to the colour
       you want to be transparent. *)
    FUNC SetBkColor(hdcMem, crTransparent);
    (* Copy the bits from the colour image to the B+W mask... everything
       with the background colour ends up white while everythig else ends up
       black...Just what we wanted. *)
    FUNC BitBlt(hdcMem2, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY);
    (* Take our new mask and use it to turn the transparent colour in our
       original colour image to black so the transparency effect will
       work right. *)
    FUNC BitBlt(hdcMem, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem2, 0, 0, SRCINVERT);
    (* Clean up. *)
    FUNC DeleteDC(hdcMem);
    FUNC DeleteDC(hdcMem2);

    RETURN hbmMask;
END CreateBitmapMask;


(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR bm       : BITMAP;
    hbmOld   : HBITMAP;
    hdc      : HDC;
    hdcMem   : HDC;
    ps       : PAINTSTRUCT;
    rcClient : RECT;
BEGIN
    CASE msg OF
    | WM_CREATE  : g_hbmBall := LoadBitmapId(Instance, IDB_BALL);
                   IF g_hbmBall = NIL THEN
                     FUNC MessageBox(hwnd, "Could not load IDB_BALL!", "Error",
                                     MB_OK BOR MB_ICONEXCLAMATION);
                   END;
                   g_hbmMask := CreateBitmapMask(g_hbmBall, RGB(0, 0, 0));
                   IF g_hbmMask = NIL THEN
                     FUNC MessageBox(hwnd, "Could not create mask!", "Error",
                                     MB_OK BOR MB_ICONEXCLAMATION);
                   END;

    | WM_PAINT   : hdc    := BeginPaint(hwnd, ps);
                   hdcMem := CreateCompatibleDC(hdc);

                   hbmOld := SelectBitmap(hdcMem, g_hbmMask);

                   FUNC GetBITMAP(g_hbmBall, bm);

                   FUNC GetClientRect(hwnd, rcClient);
                   FUNC FillRect(hdc, rcClient, GetStockBrush(LTGRAY_BRUSH));

                   BitBlt(hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem,
                          0, 0, SRCCOPY);
                   BitBlt(hdc, bm.bmWidth, 0, bm.bmWidth, bm.bmHeight, hdcMem,
                          0, 0, SRCAND);
                   BitBlt(hdc, bm.bmWidth * 2, bm.bmHeight * 2, bm.bmWidth,
                          bm.bmHeight, hdcMem, 0, 0, SRCAND);

                   SelectBitmap(hdcMem, g_hbmBall);
                   BitBlt(hdc, 0, bm.bmHeight, bm.bmWidth, bm.bmHeight, hdcMem,
                          0, 0, SRCCOPY);
                   BitBlt(hdc, bm.bmWidth, bm.bmHeight, bm.bmWidth, bm.bmHeight,
                          hdcMem, 0, 0, SRCPAINT);
                   BitBlt(hdc, bm.bmWidth * 2, bm.bmHeight * 2, bm.bmWidth,
                          bm.bmHeight, hdcMem, 0, 0, SRCPAINT);

                   FUNC SelectBitmap(hdcMem, hbmOld);
                   FUNC DeleteDC(hdcMem);

                   FUNC EndPaint(hwnd, ps);

    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : FUNC DeleteBitmap(g_hbmBall);
                   FUNC DeleteBitmap(g_hbmMask);
                   PostQuitMessage(0);
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;


VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "Another Bitmap Program",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 160,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END bmp_two.
