MODULE dlg_one;

<*/Resource:dlg_one.res*>

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,BOOL,INT_PTR;
FROM WINUSER  IMPORT WM_CLOSE,WM_DESTROY,WM_COMMAND,WM_INITDIALOG,
                     IDC_ARROW,COLOR_WINDOW,IDI_APPLICATION,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                     WNDCLASS,MSG,
                     LOWORD,MAKEINTRESOURCE,
                     DestroyWindow,PostQuitMessage,PostMessage,DefWindowProc,
                     RegisterClass,CreateWindowEx,
                     ShowWindow,UpdateWindow,
                     GetMessage,TranslateMessage,DispatchMessage,
                     LoadCursor,LoadIcon,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK,MB_ICONINFORMATION,
                     IDOK,IDCANCEL,EndDialog;
FROM WINX     IMPORT Instance,CmdShow,DialogBoxId;

FROM SYSTEM   IMPORT CAST,ADR,FUNC;

FROM resource IMPORT IDR_MYMENU,ID_FILE_EXIT,IDD_ABOUT,ID_HELP_ABOUT;

CONST
    g_szClassName = "myWindowClass";

(* *** Exported dialog procedure *** *)
PROCEDURE AboutDlgProc(hwnd : HWND; msg : UINT;
                       wParam : WPARAM; lParam : LPARAM) : INT_PTR [EXPORT, OSCall];
BEGIN
    CASE msg OF
    | WM_INITDIALOG : RETURN 1;
    | WM_COMMAND    :
      CASE LOWORD(wParam) OF
      | IDOK     : FUNC EndDialog(hwnd, IDOK);
      | IDCANCEL : FUNC EndDialog(hwnd, IDCANCEL);
      ELSE
      END;
    ELSE RETURN 0;
    END;
    RETURN 1;
END AboutDlgProc;

(* *** Exported window procedure *** *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR ret : INTEGER;
BEGIN
    CASE msg OF
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT  : FUNC PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_HELP_ABOUT : ret := DialogBoxId(Instance,
                                     IDD_ABOUT, hwnd, AboutDlgProc);
                        IF ret = IDOK THEN
                          MessageBox(hwnd, "Dialog exited with IDOK.", "Notice",
                                     MB_OK BOR MB_ICONINFORMATION);
                        ELSIF ret = IDCANCEL THEN
                          MessageBox(hwnd, "Dialog exited with IDCANCEL.", "Notice",
                                     MB_OK BOR MB_ICONINFORMATION);
                        ELSIF ret = -1 THEN
                          MessageBox(hwnd, "Dialog failed!", "Error",
                                     MB_OK BOR MB_ICONINFORMATION);
                        END;
      (* other menu commands *)
      ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
      END;
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := MAKEINTRESOURCE(IDR_MYMENU);
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "A Menu",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END dlg_one.
