MODULE dlg_two;

<*/Resource:dlg_two.res*>

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,BOOL,LPTSTR,INT_PTR;
FROM WINUSER  IMPORT WM_CLOSE,WM_DESTROY,WM_COMMAND,WM_CREATE,
                     IDC_ARROW,COLOR_WINDOW,IDI_APPLICATION,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                     WNDCLASS,MSG,
                     ShowWindow,SW_SHOW,SW_HIDE,
                     LOWORD,MAKEINTRESOURCE,
                     DestroyWindow,PostQuitMessage,PostMessage,DefWindowProc,
                     RegisterClass,CreateWindowEx,
                     UpdateWindow,
                     GetMessage,TranslateMessage,DispatchMessage,IsDialogMessage,
                     LoadCursor,LoadIcon,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK,MB_ICONINFORMATION,
                     CreateDialog;
FROM WINX     IMPORT Instance,CmdShow;

FROM SYSTEM   IMPORT CAST,ADR,FUNC,MAKEADR;

FROM resource IMPORT IDR_MYMENU,ID_FILE_EXIT,IDD_TOOLBAR,
                     IDC_PRESS,IDC_OTHER,ID_DIALOG_SHOW,ID_DIALOG_HIDE;

CONST
    g_szClassName = "myWindowClass";

VAR
    g_hToolbar : HWND;

(* *** Exported dialog procedure *** *)
PROCEDURE ToolDlgProc(hwnd : HWND; msg : UINT;
                       wParam : WPARAM; lParam : LPARAM) : INT_PTR [EXPORT, OSCall];
BEGIN
    CASE msg OF
    | WM_COMMAND    :
      CASE LOWORD(wParam) OF
      | IDC_PRESS : FUNC MessageBox(hwnd, "Hi!", "This is a message",
                                    MB_OK BOR MB_ICONEXCLAMATION);
      | IDC_OTHER : FUNC MessageBox(hwnd, "Hi!", "This is also a message",
                                    MB_OK BOR MB_ICONEXCLAMATION);
      ELSE
      END;
    ELSE RETURN 0;
    END;
    RETURN 1;
END ToolDlgProc;

(* *** Exported window procedure *** *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): INT_PTR [EXPORT, OSCall];
VAR ptr : LPTSTR;
BEGIN
    CASE msg OF
    | WM_CREATE  : ptr := MAKEADR(IDD_TOOLBAR);
                   g_hToolbar := CreateDialog(Instance, ptr^, hwnd, ToolDlgProc);
                   IF g_hToolbar # NIL THEN
                     FUNC ShowWindow(g_hToolbar, SW_SHOW);
                   ELSE
                     FUNC MessageBox(hwnd, "CreateDialog returned NIL", "Warning!",
                                     MB_OK BOR MB_ICONINFORMATION);
                   END;
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : DestroyWindow(g_hToolbar);
                   PostQuitMessage(0);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT   : FUNC PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_DIALOG_SHOW : FUNC ShowWindow(g_hToolbar, SW_SHOW);
      | ID_DIALOG_HIDE : FUNC ShowWindow(g_hToolbar, SW_HIDE);
      ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
      END;
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := MAKEINTRESOURCE(IDR_MYMENU);
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "A Menu",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       IF ~IsDialogMessage(g_hToolbar, Msg) THEN
          FUNC TranslateMessage(Msg);
          FUNC DispatchMessage(Msg);
       END;
    END;
END dlg_two.
