MODULE font_one;

<*/Resource:font_one.res*>

IMPORT COMMDLG;

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,HFONT,HMENU,
                     HDC,HBITMAP,BOOL,COLORREF,RECT,MulDiv;
FROM WINUSER  IMPORT WM_CLOSE,WM_DESTROY,WM_CREATE,WM_PAINT,
                     WM_INITMENUPOPUP,WM_COMMAND,LOWORD,
                     IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                     CS_VREDRAW,CS_HREDRAW,
                     WNDCLASS,MSG,PAINTSTRUCT,MAKEINTRESOURCE,
                     DestroyWindow,PostQuitMessage,DefWindowProc,
                     RegisterClass,CreateWindowEx,GetDC,ReleaseDC,
                     ShowWindow,UpdateWindow,GetClientRect,
                     GetMessage,TranslateMessage,DispatchMessage,
                     BeginPaint,EndPaint,LoadCursor,LoadIcon,
                     wsprintf,PostMessage,InvalidateRect,
                     CheckMenuItem,MF_BYCOMMAND,MF_CHECKED,MF_UNCHECKED,
                     DrawText,DT_WORDBREAK,DT_SINGLELINE,DT_CENTER,DT_VCENTER,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINGDI   IMPORT LOGFONT,RGB,
                     CreateFontIndirect,DEFAULT_GUI_FONT,
                     SetBkColor,SetTextColor,CreateFont,
                     GetDeviceCaps,LOGPIXELSY,
                     SetBkMode,OPAQUE,TRANSPARENT;
FROM WINX     IMPORT NIL_RECT,
                     Instance,CmdShow,
                     GetStockFont,SelectFont,GetLOGFONT,DeleteFont;

FROM SYSTEM   IMPORT CAST,ADR,FUNC;

FROM resource IMPORT IDR_MENU,ID_FILE_EXIT,ID_FORMAT_FONT,
                     ID_FORMAT_BACKGROUNDCOLOUR,ID_FORMAT_OPAQUE,
                     ID_FORMAT_DEFAULTGUIFONT,ID_FORMAT_TEST;

CONST
    g_szClassName = "myWindowClass";

VAR
    g_hfFont        : HFONT;
    g_bOpaque       : BOOL;
    g_rgbText       : COLORREF;
    g_rgbBackground : COLORREF;
    g_rgbCustom     : ARRAY [0..15] OF COLORREF;

PROCEDURE DoSelectFont(hwnd : HWND);
VAR cf : COMMDLG.CHOOSEFONT;
    lf : LOGFONT;
    hf : HFONT;
BEGIN
    FUNC GetLOGFONT(g_hfFont, lf);

    cf.lStructSize := SIZE(cf);
    cf.Flags       := COMMDLG.CF_EFFECTS BOR COMMDLG.CF_INITTOLOGFONTSTRUCT
                      BOR COMMDLG.CF_SCREENFONTS;
    cf.hwndOwner   := hwnd;
    cf.lpLogFont   := ADR(lf);
    cf.rgbColors   := g_rgbText;

    IF COMMDLG.ChooseFont(cf) THEN
       hf := CreateFontIndirect(lf);
       IF hf#NIL THEN
          g_hfFont := hf;
       ELSE
          FUNC MessageBox(hwnd, "Font creation failed!", "Error",
                          MB_OK BOR MB_ICONEXCLAMATION);
       END;
       g_rgbText := cf.rgbColors;
    END;
END DoSelectFont;

PROCEDURE DoSelectColour(hwnd : HWND);
VAR cc : COMMDLG.CHOOSECOLOR;
BEGIN
    cc.lStructSize  := SIZE(cc);

    cc.Flags        := COMMDLG.CC_RGBINIT BOR COMMDLG.CC_FULLOPEN
                       BOR COMMDLG.CC_ANYCOLOR;
    cc.hwndOwner    := hwnd;
    cc.rgbResult    := g_rgbBackground;
    cc.lpCustColors := ADR(g_rgbCustom);

    IF COMMDLG.ChooseColor(cc) THEN
       g_rgbBackground := cc.rgbResult;
    END;
END DoSelectColour;

PROCEDURE DrawClientSize(hdc : HDC; prc : RECT; hf : HFONT);
VAR Str,Title : ARRAY [0..80] OF CHAR;
    hfOld     : HFONT;
BEGIN
    Title := "These are the dimensions of your client area:";
    hfOld := SelectFont(hdc, hf);

    FUNC SetBkColor(hdc, g_rgbBackground);
    FUNC SetTextColor(hdc, g_rgbText);

    IF g_bOpaque THEN
      FUNC SetBkMode(hdc, OPAQUE);
    ELSE
      FUNC SetBkMode(hdc, TRANSPARENT);
    END;

    FUNC DrawText(hdc, Title, -1, prc, DT_WORDBREAK);

    FUNC wsprintf(Str,"{%d, %d, %d, %d}",prc.left,prc.top,prc.right,prc.bottom);
    FUNC DrawText(hdc, Str, -1, prc, DT_SINGLELINE BOR DT_CENTER BOR DT_VCENTER);

    FUNC SelectFont(hdc, hfOld);
END DrawClientSize;

(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR i        : INTEGER;
    hdc      : HDC;
    ps       : PAINTSTRUCT;
    rcClient : RECT;
    hf       : HFONT;
    lfHeight : INTEGER;
BEGIN
    CASE msg OF
    | WM_CREATE  : g_hfFont        := GetStockFont(DEFAULT_GUI_FONT);
                   g_bOpaque       := TRUE;
                   g_rgbText       := RGB(0, 0, 0);
                   g_rgbBackground := RGB(255, 255, 255);
                   FOR i:=0 TO HIGH(g_rgbCustom) DO
                     g_rgbCustom[i]:=RGB(0, 0, 0);
                   END;
    | WM_PAINT   : hdc := BeginPaint(hwnd, ps);
                   FUNC GetClientRect(hwnd, rcClient);
                   DrawClientSize(hdc, rcClient, g_hfFont);
                   FUNC EndPaint(hwnd, ps);
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : FUNC DeleteFont(g_hfFont);
                   PostQuitMessage(0);
    | WM_INITMENUPOPUP :
                   IF g_bOpaque THEN
                      CheckMenuItem(CAST(HMENU,wParam), ID_FORMAT_OPAQUE,
                                     MF_BYCOMMAND BOR MF_CHECKED);
                   ELSE
                      CheckMenuItem(CAST(HMENU,wParam), ID_FORMAT_OPAQUE,
                                     MF_BYCOMMAND BOR MF_UNCHECKED);
                   END;
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT   : PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_FORMAT_FONT : DoSelectFont(hwnd);
                         InvalidateRect(hwnd, NIL_RECT, TRUE);
                         UpdateWindow(hwnd);
      | ID_FORMAT_DEFAULTGUIFONT:
                         DeleteFont(g_hfFont);
                         g_hfFont := GetStockFont(DEFAULT_GUI_FONT);
                         InvalidateRect(hwnd, NIL_RECT, TRUE);
                         UpdateWindow(hwnd);
      | ID_FORMAT_TEST : hdc     := GetDC(hwnd);
                         lfHeight:= -MulDiv(12, GetDeviceCaps(hdc, LOGPIXELSY), 72);
                         ReleaseDC(hwnd, hdc);
                         hf := CreateFont(lfHeight, 0, 0, 0, 0, 1,
                               0, 0, 0, 0, 0, 0, 0, "Times New Roman");

                         IF hf#NIL THEN
                            DeleteFont(g_hfFont);
                            g_hfFont := hf;
                         ELSE
                            MessageBox(hwnd, "Font creation failed!", "Error",
                                       MB_OK BOR MB_ICONEXCLAMATION);
                         END;
                         InvalidateRect(hwnd, NIL_RECT, TRUE);
                         UpdateWindow(hwnd);
      | ID_FORMAT_BACKGROUNDCOLOUR:
                         DoSelectColour(hwnd);
                         InvalidateRect(hwnd, NIL_RECT, TRUE);
                         UpdateWindow(hwnd);
      | ID_FORMAT_OPAQUE :
                         g_bOpaque := NOT(g_bOpaque);
                         InvalidateRect(hwnd, NIL_RECT, TRUE);
                         UpdateWindow(hwnd);
      ELSE
      END;
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := CS_VREDRAW BOR CS_HREDRAW;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := MAKEINTRESOURCE(IDR_MENU);;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "A Font Program",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END font_one.
