MODULE menu_one;

<*/Resource:menu_one.res*>

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH;
FROM WINUSER  IMPORT WM_CLOSE,WM_DESTROY,WM_COMMAND,
                     IDC_ARROW,COLOR_WINDOW,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                     WNDCLASS,MSG,
                     LOWORD,MAKEINTRESOURCE,
                     DestroyWindow,PostQuitMessage,PostMessage,DefWindowProc,
                     RegisterClass,CreateWindowEx,
                     ShowWindow,UpdateWindow,
                     GetMessage,TranslateMessage,DispatchMessage,
                     LoadCursor,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINX     IMPORT Instance,CmdShow,
                     LoadIconId;

FROM SYSTEM   IMPORT CAST,ADR,FUNC;

FROM resource IMPORT IDR_MYMENU,IDI_MYICON,ID_FILE_EXIT,ID_STUFF_GO;

CONST
    g_szClassName = "myWindowClass";

(* *** Exported procedure *** *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
BEGIN
    CASE msg OF
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT : FUNC PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_STUFF_GO  : FUNC MessageBox(hwnd, "You clicked Go!", "Woo!", MB_OK);
      ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
      END;
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIconId(Instance,IDI_MYICON);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := MAKEINTRESOURCE(IDR_MYMENU);
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "A Menu",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END menu_one.
