MODULE menu_two;

FROM WIN32    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,HMENU,HICON;
FROM WINUSER  IMPORT WM_CREATE,WM_CLOSE,WM_DESTROY,WM_COMMAND,WM_SETICON,
                     IDC_ARROW,COLOR_WINDOW,
                     WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                     WNDCLASS,MSG,
                     LOWORD,
                     DestroyWindow,PostQuitMessage,PostMessage,DefWindowProc,
                     RegisterClass,CreateWindowEx,
                     ShowWindow,UpdateWindow,
                     SendMessage,GetMessage,TranslateMessage,DispatchMessage,
                     LoadCursor,LoadImage,IMAGE_ICON,ICON_BIG,LR_LOADFROMFILE,
                     MF_STRING,MF_POPUP,MB_ICONERROR,
                     CreateMenu,CreatePopupMenu,AppendMenu,SetMenu,
                     MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINX     IMPORT Instance,CmdShow;

FROM SYSTEM   IMPORT CAST,ADR,FUNC;

CONST
    ID_FILE_EXIT = 9001;
    ID_STUFF_GO  = 9002;

CONST
    g_szClassName = "myWindowClass";

(* *** Exported procedure *** *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR hMenu, hSubMenu : HMENU;
    hIcon           : HICON;
BEGIN
    CASE msg OF
    | WM_CREATE  : hMenu := CreateMenu();

                   hSubMenu := CreatePopupMenu();
                   FUNC AppendMenu(hSubMenu, MF_STRING, ID_FILE_EXIT, "E&xit");
                   FUNC AppendMenu(hMenu, MF_STRING BOR MF_POPUP,
                                   CAST(UINT,hSubMenu), "&File");

                   hSubMenu := CreatePopupMenu();
                   FUNC AppendMenu(hSubMenu, MF_STRING, ID_STUFF_GO, "&Go");
                   FUNC AppendMenu(hMenu, MF_STRING BOR MF_POPUP,
                                   CAST(UINT,hSubMenu), "&Stuff");

                   FUNC SetMenu(hwnd, hMenu);

                   hIcon := LoadImage(NIL, "menu_two.ico",
                                      IMAGE_ICON, 32, 32, LR_LOADFROMFILE);
                   IF hIcon#NIL THEN
                     FUNC SendMessage(hwnd, WM_SETICON, ICON_BIG, CAST(LPARAM,hIcon));
                   ELSE
                     FUNC MessageBox(hwnd, "Could not load icon!",
                                     "Error", MB_OK BOR MB_ICONERROR);
                   END;

    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    | WM_COMMAND :
      CASE LOWORD(wParam) OF
      | ID_FILE_EXIT : FUNC PostMessage(hwnd, WM_CLOSE, 0, 0);
      | ID_STUFF_GO  : FUNC MessageBox(hwnd, "You clicked Go!", "Woo!", MB_OK);
      ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
      END;
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := NIL;
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "A Menu #2",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END menu_two.
