MODULE simple_window;

FROM WIN32      IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH;
FROM WINUSER    IMPORT WM_CLOSE,WM_DESTROY,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                       WNDCLASS,MSG,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx,
                       ShowWindow,UpdateWindow,
                       GetMessage,TranslateMessage,DispatchMessage,
                       LoadCursor,LoadIcon,
                       MessageBox,MB_ICONEXCLAMATION,MB_OK;
FROM WINX       IMPORT Instance,CmdShow;

FROM SYSTEM     IMPORT CAST,ADR,FUNC;

CONST
    g_szClassName = "myWindowClass";

(* Step 4: the Window Procedure *)
(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
BEGIN
    CASE msg OF
    | WM_CLOSE   : FUNC DestroyWindow(hwnd);
    | WM_DESTROY : PostQuitMessage(0);
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN
    (* Step 1: Registering the Window Class *)
    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    (* Step 2: Creating the Window *)
    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "The title of my window",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    (* Step 3: The Message Loop *)
    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END simple_window.
