MODULE window_click;

FROM WIN32      IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH,MAX_PATH,
                       GetModuleFileName ;
FROM WINUSER    IMPORT WM_CLOSE,WM_DESTROY,WM_LBUTTONDOWN,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                       WNDCLASS,MSG,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx,
                       ShowWindow,UpdateWindow,
                       GetMessage,TranslateMessage,DispatchMessage,
                       LoadCursor,LoadIcon,
                       MessageBox,MB_ICONEXCLAMATION,MB_OK,MB_ICONINFORMATION;
FROM WINX       IMPORT Instance,CmdShow;

FROM SYSTEM     IMPORT CAST,ADR,FUNC;

CONST
    g_szClassName = "myWindowClass";

(* Exported procedure *)
PROCEDURE WndProc(hwnd : HWND; msg : UINT;
                  wParam : WPARAM;  lParam : LPARAM): LRESULT [EXPORT, OSCall];
VAR FileName  : ARRAY [0..MAX_PATH] OF CHAR;
BEGIN
    CASE msg OF
    | WM_CLOSE       : FUNC DestroyWindow(hwnd);
    | WM_DESTROY     : PostQuitMessage(0);
    | WM_LBUTTONDOWN : FUNC GetModuleFileName(Instance, FileName, MAX_PATH);
                       FUNC MessageBox(hwnd, FileName,
                       "This program is:", MB_OK BOR MB_ICONINFORMATION);
    ELSE RETURN DefWindowProc(hwnd, msg, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

VAR
    wc   : WNDCLASS;
    hwnd : HWND;
    Msg  : MSG;

BEGIN

    wc.style         := 0;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := Instance;
    wc.hIcon         := LoadIcon(NIL, IDI_APPLICATION^);
    wc.hCursor       := LoadCursor(NIL, IDC_ARROW^);
    wc.hbrBackground := CAST(HBRUSH, COLOR_WINDOW+1);
    wc.lpszMenuName  := NIL;
    wc.lpszClassName := ADR(g_szClassName);

    IF RegisterClass(wc)=0 THEN
       FUNC MessageBox(NIL, "Window Class registration failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    hwnd := CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName,
                           "The title of my window",WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
                           NIL, NIL, Instance, NIL);
    IF hwnd = NIL THEN
       FUNC MessageBox(NIL, "Window Creation failed!", "Error!",
                       MB_ICONEXCLAMATION BOR MB_OK);
       RETURN ;
    END;

    FUNC ShowWindow(hwnd, CmdShow);
    FUNC UpdateWindow(hwnd);

    WHILE GetMessage( Msg, NIL, 0, 0) DO
       FUNC TranslateMessage(Msg);
       FUNC DispatchMessage(Msg);
    END;
END window_click.
